package loopbounds;

/**
 * Exception to indicate that a loop runs 'indefinitely'.
 * This is used by the TestingUnit class, which kills testing threads after
 * running for approximately 16 seconds, assuming they are stuck in an endless loop.
 * 
 * @author Rody Kersten
 *
 */
public class IndefiniteLoopException extends Exception {
	static final long serialVersionUID = 300;
	
	/** The input to the method that was tested by TestingUnit. */
    public Object[] args;
	
    /** Constructor.
     * 
     * @param args he input to the method that was tested by TestingUnit,
     * which got it stuck in an indefinite loop.
     */
	public IndefiniteLoopException(Object[] args) {
		this.args = args;
	}
}
