package loopbounds.parsetree;

/** Exception for when an undeclared variable is used in the loop condition.
 * 
 * @author Rody Kersten
 */
public class UndeclaredVariableException extends Exception {
	static final long serialVersionUID = 207;
	
	public String var;
	
	/** Constructor.
	 * 
	 * @param type A string representation of the unsupported type.
	 */
	public UndeclaredVariableException(String var) {
		this.var = var;
	}
	
	@Override
	public String toString() {
		return new String("Undeclared variable: " + var);
	}
}
