package resanaplugin;

import java.util.Collection;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.console.ConsolePlugin;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.console.IConsoleManager;
import org.eclipse.ui.console.MessageConsole;
import org.eclipse.ui.console.MessageConsoleStream;

public class ConsoleMessager {
	public static MessageConsole findConsole(String name) {
		ConsolePlugin plugin = ConsolePlugin.getDefault();
		IConsoleManager conMan = plugin.getConsoleManager();
		IConsole[] existing = conMan.getConsoles();
		for (int i = 0; i < existing.length; i++)
			if (name.equals(existing[i].getName()))
				return (MessageConsole) existing[i];
		// no console found, so create a new one
		MessageConsole myConsole = new MessageConsole(name, null);
		conMan.addConsoles(new IConsole[] { myConsole });
		return myConsole;
	}

	public static void printCollectionToConsole(MessageConsoleStream out,
			Collection<String> col, char separator) {
		if (col.size() > 0) {
			String toBePrinted = "";
			for (String s : col) {
				toBePrinted += s + separator;
			}
			toBePrinted = toBePrinted.substring(0, toBePrinted.length() - 1);
			out.println(toBePrinted);
		}
	}
	
	public static void compilationErrorDialog(Shell shell){
		MessageDialog.openError(shell, "Compilation errors", "There are some compilation errors in your project!");
	}
}
